unit AppUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


//TDllProc = procedure;

var
  Form1: TForm1;
//  DllProcPtr : TDllProc;
  LibInstance : HMODULE; //    DLL

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
type
  TAddFunction=procedure; safecall;
var
  Hello:TAddFunction;
begin
   try
     if LibInstance>HINSTANCE_ERROR then
     begin
        Hello:=GetProcAddress(LibInstance,'Hello');
        if Assigned(Hello) then
        begin
          Hello();
        end
        else ShowMessage('Method with name Hello() was not found');
      end;
    finally
       //
    end;

end;

procedure TForm1.Button2Click(Sender: TObject);
type
  TAddFunction=function(form:THandle):boolean; safecall;
var
  AddBtn:TAddFunction;
begin
  try
     if LibInstance>HINSTANCE_ERROR then
     begin
         AddBtn:=GetProcAddress(LibInstance,'AddBtn');
         if Assigned(AddBtn) then
         begin
            AddBtn(self.Handle);
         end
         else ShowMessage('Method with name AddBtn was not found');
      end;
  finally
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    FreeLibrary(LibInstance);
    LibInstance:=0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LibInstance:=0;
  if LibInstance=0 then
  begin
    LibInstance := LoadLibrary('DelphiDLL.dll');
    if LibInstance=0 then
    begin
      ShowMessage('   DelphiDLL.dll');
      exit;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
type
  TAddFunction=function(form:THandle):boolean; safecall;
var
  AddForm:TAddFunction;
begin
  try
     if LibInstance>HINSTANCE_ERROR then
     begin
      AddForm:=GetProcAddress(LibInstance,'AddForm');
      if Assigned(AddForm) then
      begin
          AddForm(self.Handle);
      end
      else ShowMessage('Method with name AddForm was not found');
     end;
  finally
  end;
end;

end.
